#!/bin/bash
# -*- coding: utf-8 -*-
# coding: utf-8
# vim: tabstop=2 expandtab shiftwidth=2 softtabstop=2
# vim: set fileencoding=utf-8
source /scripts/basic_vars
set -o nounset
set -o pipefail
set -o errexit
#
if [ "1" != "$#" ]; then exit 0;fi
if [ -f ${NATIVE_DISABLED_FILE} ]; then exit 3;fi

if [ ! -f ${VERIFIED_LICENSE_FILE} ]; then exit 3;fi
features=`cat ${VERIFIED_LICENSE_FILE}`
if [[ "$features" != *"native_app"* ]]; then exit 3;fi


FAKE_APPNAME=${1}
APPNAME=""
APPDIR=""
CONFIG=""
USER_DATA_FILE=""
AUTOSTART="false"
APPJSON=""
exec 1> >(systemd-cat -p info -t app_onboard) 2>&1
set -o xtrace
#
sudo rm -rf /var/tmp/onboard
sudo mkdir -p /var/tmp/onboard
sudo tar xzf /home/admin/user_files/${FAKE_APPNAME}.tar.gz -C /var/tmp/onboard
#
APPJSON=$(find /var/tmp/onboard -name application.json)
APPNAME=$(/usr/bin/jq '.name' ${APPJSON} | tr -d '"' |tr '[:upper:]' '[:lower:]')
FAKEDIR=$(dirname ${APPJSON})
# can not move - cause system reboot ! and libs
cd ${FAKEDIR}
sudo tar cf /var/tmp/${APPNAME}.tar *
sudo mkdir -p /root/apps/${APPNAME}
cd /tmp
sudo tar xf /var/tmp/${APPNAME}.tar -C /root/apps/${APPNAME}
sudo rm -rf /var/tmp/onboard /var/tmp/${APPNAME}.tar
APPDIR=/root/apps/${APPNAME}
sudo cp -f /root/apps/${APPNAME}/${APPNAME}.service /lib/systemd/system
sudo systemctl daemon-reload
#
if [ -f ${APPDIR}/application.json ]; then
  CONFIG=$(/usr/bin/jq '.config' ${APPDIR}/application.json | tr -d '"')
  if [ -f ${APPDIR}/${CONFIG} ]; then
    USER_DATA_FILE=$(/usr/bin/jq '.application."user-data-file"' ${APPDIR}/${CONFIG} | tr -d '"' )
    if [ -f ${APPDIR}/${USER_DATA_FILE} ]; then
      sudo cp -f ${APPDIR}/${USER_DATA_FILE} /root/apps/${APPNAME}/sgwroot/core.cfg
    fi
    AUTOSTART=$(/usr/bin/jq '.application.autostart' ${APPDIR}/${CONFIG} | tr -d '"')
    if [ "true" = "${AUTOSTART}" ]; then
      sudo systemctl enable ${APPNAME}.service 2>/dev/null
      printf "%s\n" "${APPNAME} will start on next boot" >&2
    fi
    ROUTING=$(/usr/bin/jq '.application.routing' ${APPDIR}/${CONFIG} | tr -d '"')
    if [ "true" = "${ROUTING}" ]; then
      sysctl -w net.ipv4.ip_forward=1 || true
      sed -i '/^net.ipv4.ip_forward/d' /etc/sysctl.conf
      sed -i '${x;/^$/{s//net.ipv4.ip_forward=1/;H};x}' /etc/sysctl.conf
    else
      sysctl -w net.ipv4.ip_forward=0 || true
      sed -i '/^net.ipv4.ip_forward/d' /etc/sysctl.conf
      sed -i '${x;/^$/{s//net.ipv4.ip_forward=0/;H};x}' /etc/sysctl.conf
    fi
  fi
fi
# if somehow exists in the tar
if [ -f ${APPDIR}/successful_initialized ]; then
  rm -f ${APPDIR}/successful_initialized
fi
exit 0
