#!/bin/bash
# -*- coding: utf-8 -*-
# coding: utf-8
# vim: tabstop=2 expandtab shiftwidth=2 softtabstop=2
# vim: set fileencoding=utf-8
source /scripts/basic_vars
set -o nounset
set -o pipefail
set -o errexit
#
if [ "1" != "$#" ]; then exit 0;fi
if [ -f ${NATIVE_DISABLED_FILE} ]; then exit 3;fi
APPNAME=${1}
exec 1> >(systemd-cat -p info -t app_retrieveconfigs) 2>&1
set -o xtrace
APPJSON=/root/apps/${APPNAME}/application.json
shopt -s nocasematch
#
TMPDIR=$(mktemp -d)
if [ -f ${APPJSON} ]; then
  cp -f ${APPJSON} ${TMPDIR}
fi
APPTEMPLATE=$(/usr/bin/jq '.config' ${APPJSON} | tr -d '"')
if [ -f /root/apps/${APPNAME}/${APPTEMPLATE} ]; then
  cp -f /root/apps/${APPNAME}/${APPTEMPLATE} ${TMPDIR}
fi
USER_DATA_FILE=$(/usr/bin/jq '.application."user-data-file"' /root/apps/${APPNAME}/${APPTEMPLATE} | tr -d '"' )
if [ -f /root/apps/${APPNAME}/${USER_DATA_FILE} ]; then
  cp -f /root/apps/${APPNAME}/${USER_DATA_FILE} ${TMPDIR}
fi
if [ -f /root/apps/${APPNAME}/sgwroot/license.lic ]; then
  cp -f /root/apps/${APPNAME}/sgwroot/license.lic ${TMPDIR}
fi
cd ${TMPDIR}
tar czf /home/admin/user_files/${APPNAME}_configs.tar.gz *
cd /tmp
rm -rf ${TMPDIR}
exit 0
