#!/bin/bash
# -*- coding: utf-8 -*-
# coding: utf-8
# vim: tabstop=2 expandtab shiftwidth=2 softtabstop=2
# vim: set fileencoding=utf-8
source /scripts/basic_vars
set -o nounset
set -o pipefail
set -o errexit
#
if [ "1" != "$#" ]; then exit 0;fi
if [ -f ${NATIVE_DISABLED_FILE} ]; then exit 3;fi

if [ ! -f ${VERIFIED_LICENSE_FILE} ]; then exit 3;fi
features=`cat ${VERIFIED_LICENSE_FILE}`
if [[ "$features" != *"native_app"* ]]; then exit 3;fi

APPNAME=${1}
APPDIR=/root/apps/${APPNAME}
APPJSON=/root/apps/${APPNAME}/application.json
ONDEMAND="false"
exec 1> >(systemd-cat -p info -t app_start) 2>&1
set -o xtrace
#
sudo systemctl start ${APPNAME}.service
#
if [ -f ${APPJSON} ]; then
  ONDEMAND=$(/usr/bin/jq '.ondemand' ${APPJSON} | tr -d '"' )
  if [ "true" = ${ONDEMAND} ]; then
    #exec 1>/dev/tty
    sudo systemctl enable ${APPNAME}.service 2>/dev/null
  fi
fi
exit 0
