#!/bin/bash
# -*- coding: utf-8 -*-
# coding: utf-8
# vim: tabstop=2 expandtab shiftwidth=2 softtabstop=2
# vim: set fileencoding=utf-8
source /scripts/basic_vars
set -o nounset
set -o pipefail
set -o errexit
#
if [ "1" != "$#" ]; then exit 0;fi
if [ -f ${NATIVE_DISABLED_FILE} ]; then exit 3;fi
APPNAME=${1}
APPDIR=/root/apps/${APPNAME}
APPJSON=/root/apps/${APPNAME}/application.json
ONDEMAND="false"
exec 1> >(systemd-cat -p info -t app_stop) 2>&1
set -o xtrace
#
sudo systemctl stop --no-block ${APPNAME}.service || true
#
if [ -f ${APPJSON} ]; then
  ONDEMAND=$(/usr/bin/jq '.ondemand' ${APPJSON} | tr -d '"' )
  if [ "true" = ${ONDEMAND} ]; then
    sudo systemctl disable ${APPNAME}.service 2>/dev/null
    exec 1>/dev/tty || true
    printf "${APPNAME} will not start on next boot\n"
  fi
fi
sudo systemctl reset-failed ${APPNAME}.service || true
exit 0
