#!/usr/bin/env python3
import sys
import subprocess
import pam
import crypt

def testpass ( user, passwd ):
    #admin:$1$.hp5TjIv$LxlyBslHaHCxj2il6/dYW0:18883:0:99999:7:::
    try:
        passFile = open ("/etc/shadow",'r')
        for linel in passFile.readlines():
                line = linel.replace("\n","").split(":")
                if line[0] == user and (len(linel) > 4) and line[1] and line[1].count("$")>=3:
                    pass_elem=line[1].split("$")
                    if pass_elem[1]=="1":
                        salt = "$1$" + pass_elem[2]
                        pass_crypt = crypt.crypt(passwd,salt)
                        if pass_crypt == line[1]:
                            return 0
                        return 1
        return 1
    except Exception as e:
        return 1

if __name__ == '__main__':
    argc = len(sys.argv)
    if argc < 3:
        print("Authentication failed! User or password missing!")
        sys.exit(1)
    
    service = subprocess.check_output(['sysrepocfg', '--datastore=running', '--format=json', '--xpath', '/ucpe:config//security:security//authentication//auth-type', '--export']).decode("utf-8")
    #print('Authentication service {} '.format(service))
    if service.find('"auth-type": "tacacs"') > -1:
        auth_service = "pam_tacacs"
    elif service.find('"auth-type": "radius"') > -1:
        auth_service = "pam_radius_auth"
    else:
        auth_service = "system_auth"

    user = sys.argv[1]
    passw = sys.argv[2]

    # Authentication for internal API user
    if 'a1bfb873ca23417fce59461a940a114f' == user:
        if testpass(user, passw):
            print("Authentication failed for user {}!".format(user))
            exit(1)
        print("Authenticated user {}!".format(user))
        exit(0)

#    print(user, passw)
    p = pam.pam()
    #login = p.authenticate(user,passw,service="system-auth")
    login = p.authenticate(user,passw, service=auth_service)
    if login == True:
        print("Authenticated user {}!".format(user))
        exit(0)

    print("Authentication failed for user {}!".format(user))
    exit(1)
