#!/usr/bin/python3
import jwt
import sys
from cryptography.hazmat.primitives import serialization
from cryptography.hazmat.backends import default_backend

public_key_file = "/home/public.pem"

def check_token_expired(token):
    with open(public_key_file, "rb") as f:
        public_key = serialization.load_pem_public_key(
            f.read(), backend=default_backend()
        )                
    try:
        decoded = jwt.decode(token, key=public_key, algorithms=["RS256"])
        print("Token is valid!!")
        return False
    except jwt.ExpiredSignatureError:
        # Signature has expired
        print("Token has expired!!")
        return True
    except Exception as e:
        print("Token is not valid!!")
        return True
     

if __name__ == "__main__":
    argc = len(sys.argv)
    if argc < 2:
        print("No enough arguments. Exit!")
        sys.exit(1)
    elif argc == 2:
        print('token: %s' % sys.argv[1])
        check_token_expired(sys.argv[1])
    sys.exit(0)
 
