#! /usr/bin/env python3
import json
import os

UCPE_STATUS_FILE = "/config/_hb/ucpe_status.json"
UCPE_STATUS_FILE_TEMPLATE = "{\"ucpe:status\": {\"status\": \"unknown\", \"hb-status\": \"unknown\", \"nsStatus\": \"unknown\", \"ztp-status\": \"unknown\", \"certs\": \"default\", \"license-id\": \"unknown\", \"apps\": \"false\", \"cluster\": {}, \"appslist\":{}}}"


def update_status_file(key, value):
    if not (os.path.isfile(UCPE_STATUS_FILE)):
        lic_file = open(UCPE_STATUS_FILE, 'w')
        data = json.loads(UCPE_STATUS_FILE_TEMPLATE)
        data['ucpe:status'][key] = str(value)
        json.dump(data, lic_file)
        lic_file.close()
        os.chmod(UCPE_STATUS_FILE, 0o777)
    else:
        with open(UCPE_STATUS_FILE, "r+", encoding='utf-8') as json_file:
            data = json.load(json_file)

            data['ucpe:status'][key] = str(value)

            json_file.seek(0)
            json.dump(data, json_file)
            json_file.truncate()
            json_file.close()


if __name__ == "__main__":
    update_status_file('license-id', 'unknown')
