#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import sys
import syslog
from sysrepo_portmirroring import sysrepo_portmirroring as api

def validate_port_mirror(pm, name):
    
    mirror = next((mirrors for mirrors in pm.get_port_mirrors().keys() if mirrors == name), None)

    if not mirror:
        pm.set_port_mirror(name)
   
    # DI: TODO: have to validate all params

def set_mirror(name, param, value):
    if not param or not value:
        print("Error applying Port Mirroring configuration.")
        return

    pm = api.SysrepoPortMirroring(app_name="set port mirror")

    validate_port_mirror(pm, name)
    
    if param == "enable":
        pm.set_port_mirror_param(name, param, True if int(value) == 1 else False)
    else:
        pm.set_port_mirror_param(name, param, value)
    pm.commit()


def del_mirror(name):
    pm = api.SysrepoPortMirroring(app_name="del port mirror")
    pm.unset_port_mirror(name)
    pm.commit()

if __name__ == "__main__":
    argc = len(sys.argv)

    if 3 > argc:
        syslog.syslog(syslog.LOG_ERR, "No enough arguments. Exit!")
        sys.exit(1)
    if sys.argv[1] == "set_port_mirroring":
        if sys.argv[3] == "delete":
            del_mirror(sys.argv[2])
        else:
            set_mirror(sys.argv[2], sys.argv[3], sys.argv[4])
    else:
        syslog.syslog(syslog.LOG_ERR, "Unknown argument \"%s\"" % sys.argv[1])
        sys.exit(1)

    sys.exit(0)
