#!/bin/bash
# -*- coding: utf-8 -*-
# change to 0 !!!

### INIT VARS
source /scripts/basic_vars

### SOURCE SAME BASIC FUNCTIONS NEEDED
source /scripts/basic_functions

DEBUG=0
function klish_echo () {
  if [ 1 == $DEBUG ]; then
      echo
      echo "$@"
      echo
  fi
}

function klish_json_set () {
  local command_header=${1}
  local command_path=${2}
  local python_executable_path=${3}
  shift 3
  #klish_echo "$FUNCNAME:$LINENO:$@"
  local key_value_type_string=""
  while [ $# -gt 0 ]; do
    local key=${1}
    local new_value=${2}
    local convert_type=${3}
    if [ "null" != "${convert_type}" ] ; then
        key_value_type_string+=" ${key} ${new_value} ${convert_type} "
    fi
    shift 3
  done
  if [ -z ${key_value_type_string} ] ; then
      return 0
  fi
  #klish_echo "$FUNCNAME:$LINENO:${key_value_type_string}"
  local json_file_to_send=`mktemp`
  local curl_resp=`mktemp`
  local command_replace="| python3 ${python_executable_path}/klish_json_set.py ${json_file_to_send} ${key_value_type_string}"
  local command_get="${command_header} ${command_path} -X GET $command_replace"
  #klish_echo "${command_get}"
  eval "$command_get"
  #klish_echo "file:"
  #klish_echo "`cat ${json_file_to_send}`"
  local command_set="$command_header -w '%{http_code}' ${command_path} -X PUT --data @${json_file_to_send}"
  #klish_echo "$command_set"
  eval "$command_set > ${curl_resp}"
  curl_ret=$(cat $curl_resp)
  klish_echo "Got reponse `cat ${curl_resp}`"
  rm -f ${json_file_to_send}
  rm -f ${curl_resp}
  if [ "$curl_ret"  == "200" ] ; then
      return 0
  else
      echo -e "The action was not successful \nNo changes will be applied"
  fi
  return 1
}

function klish_json_set_array () {
  local command_header=${1}
  local command_path=${2}
  local command_match=${3}
  local python_executable_path=${4}
  shift 4
  #klish_echo "$FUNCNAME:$LINENO:$@"
  local key_value_type_string=""
  while [ $# -gt 0 ]; do
    local key=${1}
    local new_value=${2}
    local convert_type=${3}
    if [ "null" != "${convert_type}" ] ; then
        key_value_type_string+=" ${key} ${new_value} ${convert_type} "
    fi
    shift 3
  done
  if [ -z "${key_value_type_string}" ] ; then
      return 0
  fi
  #klish_echo "$FUNCNAME:$LINENO:${key_value_type_string}"
  local json_file_to_send=`mktemp`
  local curl_resp=`mktemp`
  local command_replace="| python3 ${python_executable_path}/klish_json_set.py --array ${command_match} ${json_file_to_send} ${key_value_type_string}"
  local command_get="${command_header} ${command_path} -X GET $command_replace"
  #klish_echo "${command_get}"
  eval "$command_get"
  #klish_echo "file:"
  #klish_echo "`cat ${json_file_to_send}`"
  local command_set="$command_header -w '%{http_code}' ${command_path} -X PUT --data @${json_file_to_send}"
  #klish_echo "$command_set"
  eval "$command_set > ${curl_resp}"
  curl_ret=$(cat $curl_resp)
  #klish_echo "Got reponse `cat ${curl_resp}`"
  rm -f ${json_file_to_send}
  rm -f ${curl_resp}
  if [ "$curl_ret"  == "200" ] ; then
      return 0
  else
    echo -e "The action was not successful \nNo changes will be applied"
  fi
  return 1
}

export -f klish_echo
export -f klish_json_set
