#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import sys
import json
from distutils.util import strtobool
import logging
logging.basicConfig(level=logging.ERROR, format='%(asctime)s - %(levelname)s - %(message)s')
#logging.basicConfig(level=logging.DEBUG, format='%(asctime)s - %(levelname)s - %(message)s')

def magic_replace(obj,key,value,string_to_func):
    if "none" == string_to_func:
        obj[key]=value
    elif "int" == string_to_func:
        obj[key]=int(value)
    elif "number" == string_to_func:
        obj[key]=float(value)
    elif "bool" == string_to_func:
        try:
            obj[key]=bool(strtobool(str(value)))
        except ValueError, e:
            raise SystemExit(e)
    else:
        raise Exception('Unknown json type, check TVE.json for valid types '+string_to_func)

    return
# END def magic_replace(obj,key,value,string_to_func)

def main():
    infile = sys.stdin
    array_match = None
    with infile:
        try:
            obj = json.load(infile)
        except ValueError, e:
            raise SystemExit(e)

    if '--array' == sys.argv[1]:
        array_match = sys.argv[2]
        outfile = open(sys.argv[3], 'wb')
        in_args_offset = 4
    else:
        in_args_offset = 2
        outfile = open(sys.argv[1], 'wb')

    logging.debug ("Number of arguments:%d", len(sys.argv));
    i = 0

    if array_match is not None:
        srch_key,srch_val = array_match.split("=")
        obj_filters = [x for x in obj if x[srch_key] == srch_val]
        obj_target = obj_filters[0]
    else:
        obj_target = obj

    while i < (len(sys.argv) - in_args_offset ):
        key = sys.argv[in_args_offset+i]
        value = sys.argv[in_args_offset+1+i]
        string_to_func = sys.argv[in_args_offset+2+i]
        path_key = key.split("/")
        logging.debug ("Iteration %d key %s value %s string_to_func %s, array %s", i, path_key[-1], value, string_to_func, array_match);
        if len(path_key)  > 1:
            magic_replace ( obj_target[path_key[-2]], path_key[-1], value, string_to_func )
        else:
            magic_replace ( obj_target, path_key[-1], value, string_to_func )

        i = i + 3

    with outfile:
        json.dump(obj, outfile, sort_keys=True,
                  indent=2, separators=(',', ': '))
        outfile.write('\n')
    return
# END def main()

if __name__ == '__main__':
    main()
