#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import sys
import getopt
import aptsources.sourceslist

distr='nfvtimeos'
comps=[ 'main' ]

def set_nfvt_url( url, clean ):

    #Find all entries for nfvtime and delete/comment them
    sr = aptsources.sourceslist.SourcesList()

    to_remove = []

    for sl in sr:
        if sl.disabled or sl.invalid:
            continue

        if sl.dist == distr and clean:
            to_remove.append( sl )


    for rem in to_remove:
        sr.remove( rem )


    sr.add('deb', url, distr, comps )
    sr.save()



    #     print "%s %s %s" % (sl.invalid, sl.disabled, sl.dist )


def print_help( name ):
    print ('%s -u <URL of repository> -c' % name)
    print ("Params:")
    print (" -u --url <URL> \t URL of repository")
    print (" -c --clean  \t Clean old entries")
    print (" -h \t This help")

def main(name, argv):
    url = None
    clean = False

    try:
        opts, args = getopt.getopt(argv,"u:ch",["url=","clean"])
    except getopt.GetoptError as err:
        print_str( err )
        print_help( name )
        sys.exit(2)

    for opt, arg in opts:
      if opt == '-h':
          print_help( name )
          sys.exit(0)
      elif opt in ("-u", "--url"):
          url = arg
      elif opt in ("-c", "--clean"):
          clean = True

    if url is None and clean is None:
        print ("No URL provided")
        pirnt_help( name )
        sys.exit(2)

    if url is not None:
        set_nfvt_url( url, clean )



if __name__ == "__main__":
    if len( sys.argv ) == 1:
        print ("HHHH")
        print_help( sys.argv[0])
        sys.exit( 1 )

    main(sys.argv[0], sys.argv[1:])
