#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import sys
from distutils.util import strtobool
from sysrepo_quagga import sysrepo_quagga as api

def set_state(new_state):
    system = api.SysrepoQuagga(app_name="set quagga")
    new_state=bool(strtobool(str(new_state)))
    system.set_enabled(new_state)
    system.commit()

def set_protocol(new_server, new_filename, new_hash, new_password, new_protocol, new_username, proto_string):

    system = api.SysrepoQuagga(app_name="set quagga")

    if proto_string == "zebrad-config":
        system.set_zebrad_config_param('config-server', new_server)
        system.set_zebrad_config_param('filename', new_filename)
        system.set_zebrad_config_param('hash-sum', new_hash)
        if new_password != '""': system.set_zebrad_config_param('password', new_password)
        system.set_zebrad_config_param('protocol', new_protocol)
        system.set_zebrad_config_param('username', new_username)
    if proto_string == "ospfd-config":
        system.set_ospfd_config_param('config-server', new_server)
        system.set_ospfd_config_param('filename', new_filename)
        system.set_ospfd_config_param('hash-sum', new_hash)
        if new_password != '""': system.set_ospfd_config_param('password', new_password)
        system.set_ospfd_config_param('protocol', new_protocol)
        system.set_ospfd_config_param('username', new_username)
    if proto_string == "ospf6d-config":
        system.set_ospf6d_config_param('config-server', new_server)
        system.set_ospf6d_config_param('filename', new_filename)
        system.set_ospf6d_config_param('hash-sum', new_hash)
        if new_password != '""': system.set_ospf6d_config_param('password', new_password)
        system.set_ospf6d_config_param('protocol', new_protocol)
        system.set_ospf6d_config_param('username', new_username)
    if proto_string == "bgpd-config":
        system.set_bgpd_config_param('config-server', new_server)
        system.set_bgpd_config_param('filename', new_filename)
        system.set_bgpd_config_param('hash-sum', new_hash)
        if new_password != '""': system.set_bgpd_config_param('password', new_password)
        system.set_bgpd_config_param('protocol', new_protocol)
        system.set_bgpd_config_param('username', new_username)

    system.commit()

if __name__ == "__main__":

    if sys.argv[1] == "set_state":
        set_state(sys.argv[2])
        sys.exit( 0 )
    if sys.argv[1] == "set_zebra":
        set_protocol(sys.argv[2], sys.argv[3], sys.argv[4], sys.argv[5], sys.argv[6], sys.argv[7], "zebrad-config")
        sys.exit( 0 )
    if sys.argv[1] == "set_ospf":
        set_protocol(sys.argv[2], sys.argv[3], sys.argv[4], sys.argv[5], sys.argv[6], sys.argv[7], "ospfd-config")
        sys.exit( 0 )
    if sys.argv[1] == "set_ospf6":
        set_protocol(sys.argv[2], sys.argv[3], sys.argv[4], sys.argv[5], sys.argv[6], sys.argv[7], "ospf6d-config")
        sys.exit( 0 )
    if sys.argv[1] == "set_bgp":
        set_protocol(sys.argv[2], sys.argv[3], sys.argv[4], sys.argv[5], sys.argv[6], sys.argv[7], "bgpd-config")
        sys.exit( 0 )

