#!/bin/bash

function set_bgp() {
    IFS='#' tokens=( $1 )
    local new_server=${tokens[0]}
    local new_filename=${tokens[1]}
    local new_protocol=${tokens[2]}
    local new_hash=${tokens[3]}
    local new_username=${tokens[4]}
    local new_password=${tokens[5]}
    
    empty_string='""'
    
    if [ ! ${new_password} ]; then
      new_password=${empty_string}
    fi

    /scripts/cli/tvesh/quagga-commands.py set_bgp ${new_server} ${new_filename} ${new_hash} ${new_password} ${new_protocol} ${new_username}

}

function set_ospf() {
    IFS='#' tokens=( $1 )
    local new_server=${tokens[0]}
    local new_filename=${tokens[1]}
    local new_protocol=${tokens[2]}
    local new_hash=${tokens[3]}
    local new_username=${tokens[4]}
    local new_password=${tokens[5]}

    empty_string='""'
    
    if [ ! ${new_password} ]; then
      new_password=${empty_string}
    fi

    /scripts/cli/tvesh/quagga-commands.py set_ospf ${new_server} ${new_filename} ${new_hash} ${new_password} ${new_protocol} ${new_username}

}

function set_ospf6() {
    IFS='#' tokens=( $1 )
    local new_server=${tokens[0]}
    local new_filename=${tokens[1]}
    local new_protocol=${tokens[2]}
    local new_hash=${tokens[3]}
    local new_username=${tokens[4]}
    local new_password=${tokens[5]}

    empty_string='""'
    
    if [ ! ${new_password} ]; then
      new_password=${empty_string}
    fi

    /scripts/cli/tvesh/quagga-commands.py set_ospf6 ${new_server} ${new_filename} ${new_hash} ${new_password} ${new_protocol} ${new_username}

}

function set_zebra() {
    IFS='#' tokens=( $1 )
    local new_server=${tokens[0]}
    local new_filename=${tokens[1]}
    local new_protocol=${tokens[2]}
    local new_hash=${tokens[3]}
    local new_username=${tokens[4]}
    local new_password=${tokens[5]}

    empty_string='""'
    
    if [ ! ${new_password} ]; then
      new_password=${empty_string}
    fi

    /scripts/cli/tvesh/quagga-commands.py set_zebra ${new_server} ${new_filename} ${new_hash} ${new_password} ${new_protocol} ${new_username}

}

function set_enabled() {
    IFS='#' tokens=( $1 )
    local new_state=${tokens[0]}
    /scripts/cli/tvesh/quagga-commands.py set_state ${new_state}
}
case "$1" in
  set_bgp)
    set_bgp $2
    ;;
  set_ospf)
    set_ospf $2
    ;;
  set_ospf6)
    set_ospf6 $2
    ;;
  set_zebra)
    set_zebra $2
    ;;
  set_enabled)
    set_enabled $2
    ;;
  *)
    echo "Unknown operation"
    exit 1
    ;;
esac

exit 0
