#!/bin/bash
source /scripts/basic_vars
source /scripts/basic_functions

function show_tunnel_statistics() {
  local vxlanX_name=$1
  local isvalid=$(sudo sysrepocfg --datastore=running --format=json --xpath="/ucpe:config/interfaces:interface//*" --export | json2yaml | grep " name" | grep $vxlanX_name | cut -f2 -d:)
    if [ -z "${isvalid}" ]; then
      echo "Invalid interface" $vxlanX_name
        exit 1
    fi
    local vxlan_tunnels
    local tap5xX
    local local_vtep
    local remote_vtep
    local bridge_domain_index
    local -a bridge_domain_tunnels
      tap5xx=$(echo "tap$((500 + ${vxlanX_name:5}))")
      bridge_domain_index=$(sudo /usr/bin/vppctl show int ${tap5xx} addr | grep bd-id | awk '{print $4}')
      vxlan_tunnels=$(sudo /usr/bin/vppctl show bridge-domain ${bridge_domain_index} det | grep vxlan_tunnel | awk '{print $1}' | tr '\n' ' ')
      IFS=' ' read -ra vxlan_tunnelX <<< "$vxlan_tunnels"
      local_vtep=$(sudo /usr/bin/sysrepocfg --datastore=running --format=json --xpath="/ucpe:config/interfaces:interface[name='${vxlanX_name}']/local//*" --export | grep vtep-addr | awk '{print $2}' | cut -d '"' -f2)
      echo "Tunnel: $vxlanX_name"
      echo "Local-vtep: $local_vtep"
      echo "-----------------------------------------------------------------------------------"
      for vxlan_tunnelX in "${vxlan_tunnelX[@]}"; do # access each element of array
        echo "$(sudo /usr/bin/vppctl show interface $vxlan_tunnelX)"
        remote_vtep=$(sudo /usr/bin/vppctl show vxlan tunnel | grep "instance ${vxlan_tunnelX:12}" | awk '{print $7}')
        echo "Remote-vtep:  $remote_vtep"
        echo "-----------------------------------------------------------------------------------"
      done
}


show_tunnel_statistics $1
