#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import sys
import syslog
from sysrepo_snmp import sysrepo_snmp as api

def set_enable(p1, p2, p3, p4, p5, p6, p7, p8):
    system = api.SysrepoSNMP(app_name="set snmp")

    # System information
    if p1 == "1":
        system.set_enable(True)
    else:
        system.set_enable(False)

    system.set_bind_address(p2)
    system.set_port(int(p3))

    if p4 == "1":
        system.set_authentication_failure_trap_enabled(True)
    else:
        system.set_authentication_failure_trap_enabled(False)

    if '""' != p5:
        system.set_system_name(p5)
    else:
        system.set_system_name('')

    if '""' != p6:
        system.set_system_location(p6)
    else:
        system.set_system_location('')

    if '""' != p7:
        system.set_system_contact(p7)
    else:
        system.set_system_contact('')

    if '""' != p8:
        system.set_system_description(p8)
    else:
        system.unset_system_description()

    system.commit()


def set_view(p1, p2, p3, p4):
    system = api.SysrepoSNMP(app_name="set snmp")

    # VACM Configuration
    # View
    system.set_view(int(p1))
    system.set_view_param(int(p1), 'type', p3)
    system.set_view_param(int(p1), 'oid', p4)
    if '""' != p2:
        system.set_view_param(int(p1), 'name', p2)
    else:
        system.unset_view_param(int(p1), 'name')

    system.commit()


def set_user(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12):
    system = api.SysrepoSNMP(app_name="set snmp")
    # VACM Configuration
    # Users
    system.set_user(int(p1))
    system.set_user_param(int(p1), 'message-model', p3)
    system.set_user_param(int(p1), 'security-level', p4)
    system.set_user_param(int(p1), 'auth-type', p5)


    if '""' != p2:
        system.set_user_param(int(p1), 'user-name', p2)
    else:
        system.unset_user_param(int(p1), 'user-name')

    if '""' != p6:
        system.set_user_param(int(p1), 'auth-password', p6)
    else:
        system.unset_user_param(int(p1), 'auth-password')

    system.set_user_param(int(p1), 'priv-type', p7)

    if '""' != p8:
        system.set_user_param(int(p1), 'priv-password', p8)
    else:
        system.unset_user_param(int(p1), 'priv-password')

    if '""' != p9:
        system.set_user_param(int(p1), 'remote-engine-id', p9)
    else:
        system.unset_user_param(int(p1), 'remote-engine-id')

    if '""' != p10:
        system.set_user_param(int(p1), 'read-view', p10)
    else:
        system.unset_user_param(int(p1), 'read-view')

    if '""' != p11:
        system.set_user_param(int(p1), 'write-view', p11)
    else:
        system.unset_user_param(int(p1), 'write-view')

    if '""' != p12:
        system.set_user_param(int(p1), 'notify-view', p12)
    else:
        system.unset_user_param(int(p1), 'notify-view')

    system.commit()

def set_target_address(self, id):
    self.set_item("{}/target-address[id='{}']".format(self.namespace, id), id)

def set_target_address_param(self, id, param, value):
    self.set_item("{}/target-address[id='{}']/{}".format(self.namespace, id, param), value)


def set_targets(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11):
    system = api.SysrepoSNMP(app_name="set snmp")

    system.set_target_address(int(p1))
    if p2 == "1":
        system.set_target_address_param(int(p1), 'enable', True)
    else:
        system.set_target_address_param(int(p1), 'enable', False)

    if '""' != p3:
        system.set_target_address_param(int(p1), 'target-addr-name', p3)
    else:
        system.unset_target_address_param(int(p1), 'target-addr-name')

    if '""' != p4:
        system.set_target_address_param(int(p1), 'security-name', p4)
    else:
        system.unset_target_address_param(int(p1), 'security-name')

    system.set_target_address_param(int(p1), 'message-model', p5)
    system.set_target_address_param(int(p1), 'security-level', p6)

    if '""' != p5:
        system.set_target_address_param(int(p1), 'dst-address', p7)
    else:
        system.unset_target_address_param(int(p1), 'dst-address')

    system.set_target_address_param(int(p1), 'dst-port', int(p8))
    system.set_target_address_param(int(p1), 'timeout', int(p9))
    system.set_target_address_param(int(p1), 'retry-count', int(p10))
    system.set_target_address_param(int(p1), 'type', p11)

    system.commit()


if __name__ == "__main__":
    argc = len( sys.argv )
    if 2 > argc:
        syslog.syslog( syslog.LOG_ERR, "No enough arguments. Exit!" )
        sys.exit(1)
    if sys.argv[1] == "set_enable":
        set_enable(sys.argv[2], sys.argv[3], sys.argv[4], sys.argv[5], sys.argv[6], sys.argv[7], sys.argv[8], sys.argv[9])
    elif sys.argv[1] == "set_view":
        set_view(sys.argv[2], sys.argv[3], sys.argv[4], sys.argv[5])
    elif sys.argv[1] == "set_user":
        set_user(sys.argv[2], sys.argv[3], sys.argv[4], sys.argv[5], sys.argv[6], sys.argv[7], sys.argv[8], sys.argv[9], sys.argv[10], sys.argv[11], sys.argv[12], sys.argv[13])
    elif sys.argv[1] == "set_targets":
        set_targets(sys.argv[2], sys.argv[3], sys.argv[4], sys.argv[5], sys.argv[6], sys.argv[7], sys.argv[8], sys.argv[9], sys.argv[10], sys.argv[11], sys.argv[12])
    else:
        syslog.syslog( syslog.LOG_ERR, "Unknown argument \"%s\"" % sys.argv[1] )
        sys.exit(1)

    sys.exit(0)

