#!/bin/bash
# -*- coding: utf-8 -*-

resolv_conf="/etc/systemd/resolved.conf"

function create_domain() {
    domain=$1
    if [ -n "$domain" ]; then
            sed -i -e "s/Domains[ ]*=.*/Domains = ${domain}/" "$resolv_conf"
	    systemctl restart systemd-resolved.service
        fi
}

function delete_domain() {
    domain=$1
    if [ -n "$domain" ]; then
            sed -i -e "s/Domains[ ]*=.*${domain}.*/Domains = /" "$resolv_conf"
	    systemctl restart systemd-resolved.service
        fi
}


case "$1" in
  create_domain)
    create_domain $2
    ;;
  delete_domain)
    delete_domain $2
    ;;
  *)
    echo "Unknown operation"
    exit 1
    ;;
esac

exit 0

