#!/bin/bash
# -*- coding: utf-8 -*-

function is_ip_address() {
    cat << EOF > /tmp/pyscript.py
#!/usr/bin/env python3
import sys
from netaddr import *

for i in sys.stdin:
    IPNetwork(i.strip('\n'))
sys.exit(0)

EOF
    chmod 755 /tmp/pyscript.py

    echo $1 | /tmp/pyscript.py 2>/dev/null
    if [ $? -eq 0 ]; then
        rm -f /tmp/pyscript.py
        return 0
    else
        rm -f /tmp/pyscript.py
        return 1
    fi
}

function restore_hosts_to_ASCII() {
    # if somehow /etc/hosts become data
    # and if is data many operation will fail
    # try to revert it to ASCII
  
    if [[ "data" = "$(file -b /etc/hosts)" ]]; then
      cat /etc/hosts | xargs -0 echo > /etc/hosts.ascii
      rm -f /etc/hosts
      mv /etc/hosts.ascii /etc/hosts
    fi

    return
}

function create_mapping() {
    IFS='#' tokens=( $1 )
    local address=${tokens[0]}
    local hostname1=${tokens[1]}
    local hostname2=${tokens[2]}
    local hostname3=${tokens[3]}
    local hostname4=${tokens[4]}
    local hostname5=${tokens[5]}
    is_ip_address $address
    if [ $? -eq 1 ]; then
        echo "$address is not a valid address!"
        return
    fi
    restore_hosts_to_ASCII
    local checkinfile=$(grep $address /etc/hosts | wc -l)
    if [ $checkinfile -ne 0 ]; then
      sudo sed -i "/${address}\\s*/d" /etc/hosts
    fi

    echo "$address $hostname1 $hostname2 $hostname3 $hostname4 $hostname5" >> /etc/hosts
}

function remove_mapping() {
    IFS='#' tokens=( $1 )
    local address=${tokens[0]}

    restore_hosts_to_ASCII
    local numline=$(grep -n "^$address " /etc/hosts | cut -f1 -d : | head -1)
    if [ ! -z ${numline} ]; then
        sed -i "${numline} d" /etc/hosts
    fi
}


case "$1" in
  create_mapping)
    create_mapping $2
    ;;
  remove_mapping)
    remove_mapping $2
    ;;
  *)
    echo "Unknown operation"
    exit 1
    ;;
esac

exit 0

