#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import sys
from distutils.util import strtobool
from sysrepo_syslog import sysrepo_syslog as api

def config_syslog_server(server_id, new_state, new_ip, new_port, new_facility, new_severity):
    system = api.SysrepoSyslog(app_name="set syslog")

    server_id=int(server_id)
    system.set_remote_server(server_id)
    new_state=bool(strtobool(str(new_state)))
    system.set_remote_server_param(server_id, 'enable', new_state)
    if new_facility=="mktemp" or new_facility=="*":
        new_facility='all'

    system.set_remote_server_param(server_id, 'facility', new_facility)
    system.set_remote_server_param(server_id, 'ip-address', new_ip)
    new_port=int(new_port)
    system.set_remote_server_param(server_id, 'port', new_port)
    if new_severity=="mktemp" or new_severity=="*":
        new_severity='all'

    system.set_remote_server_param(server_id, 'severity', new_severity)

    system.commit()

if __name__ == "__main__":

    if sys.argv[1] == "syslog_config":
        config_syslog_server(sys.argv[2], sys.argv[3], sys.argv[4], sys.argv[5], sys.argv[6], sys.argv[7])
        sys.exit( 0 )
