#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import sys
import syslog
import subprocess
import json

basic_headers = 'curl -s -H \"Content-type: application/json\" '
empty_string='""'

def set_ovpn (token, ssl_insecure, tve_ip, name, new_enable, new_management, new_type, new_ovpn_endpoint, new_ovpn_port):

    command_headers = basic_headers + '-H \"X-Auth-Token:' + token + '\" '
    if ssl_insecure == "true" or ssl_insecure == "True":
        command_headers+='--insecure'

    get_command = command_headers + ' -X GET https://' + tve_ip + ':7373/v1/config/networking/interfaces | python3 -mjson.tool'
    get_result = subprocess.check_output ( get_command , shell=True )
    interfaces = json.loads(get_result)

    for interface in interfaces:
        if interface['name'] != name:
            continue

        if new_enable != '""': interface['enable'] = True if int(new_enable) == 1 else False
        if new_management != '""': interface['management'] = True if int(new_management) == 1 else False
        if new_ovpn_endpoint != '""': interface['ovpn-cfg']['concentrator-endpoint'] = new_ovpn_endpoint
        if new_ovpn_port != '""': interface['ovpn-cfg']['concentrator-port'] = int(new_ovpn_port)

    command = command_headers + ' -X PUT https://' + tve_ip + ':7373/v1/config/networking/interfaces -d \'' + json.dumps(interfaces, sort_keys=True, indent=4, separators=(',', ': ')) + '\''

    try:
        subprocess.check_output ( command , shell=True )
    except subprocess.CalledProcessError as ex:
        syslog.syslog( syslog.LOG_ERR, "Command \"%s\" failed with code %d" % (ex.cmd, ex.returncode) )
        sys.exit(1)
    except OSError as ex:
        syslog.syslog( syslog.LOG_ERR, "System error - \"%s\"" % ex.strerror )
        sys.exit(1)

if __name__ == "__main__":
    argc = len( sys.argv )

    if 3 > argc:
        syslog.syslog( syslog.LOG_ERR, "No enough arguments. Exit!" )
        sys.exit( 1 )
    if sys.argv[1] == "set_ovpn":
        set_ovpn(sys.argv[2], sys.argv[3], sys.argv[4], sys.argv[5], sys.argv[6], sys.argv[7], sys.argv[8], sys.argv[9], sys.argv[10])
    else:
        syslog.syslog( syslog.LOG_ERR, "Unknown argument \"%s\"" % sys.argv[1] )
        sys.exit(1)

    sys.exit(0)

