#!/bin/bash

### SCRIPT TO REBOOT THE UCPE WITH A DELAY

source /scripts/basic_vars
sleep_count=0

if [ "$?" -ne 0 ]; then
  echo "Variable file missing!"
  exit 1
fi

if [[ "$1" == *"tve"* ]]; then
  touch $reboot_in_progress
  /scripts/hb_update.py 
  /bin/sleep $2
  /usr/bin/snmptrap -v 2c -c monitoring -r 3 -t 7 edge-manager:1062 "" SNMPv2-MIB::warmStart 2>/dev/null
  /scripts/send_netconf_restart_notif warm  
  homecalling_running=$(systemctl status homecalling | head -3 | grep running | wc -l)
  homecalling_sh_running=$(ps -C homecalling.sh --no-headers | wc -l)
  homecalling_api_running=$(ps -C homecalling-api.sh --no-headers | wc -l)
  while [[ "$homecalling_running" -eq 1 ]] || [[ "$homecalling_sh_running" -eq 1 ]] || [[ "$homecalling_api_running" -eq 1 ]]; do
    echo "Homecalling is still running, postponing reboot, sleep $sleep_count "
    sleep 3    
    let sleep_count+=1
    if [ "$sleep_count" -ge 100 ]; then
      break
    fi
    homecalling_running=$(systemctl status homecalling | head -3 | grep running | wc -l)
    homecalling_sh_running=$(ps -C homecalling.sh --no-headers | wc -l)
    homecalling_api_running=$(ps -C homecalling-api.sh --no-headers | wc -l)
  done

  #licensing in progress
  sleep_count=0
  while [ -f /tmp/license_in_progress ] ;
  do
      sleep 1
      let sleep_count+=1
      if [ "$sleep_count" -ge 10 ]; then
        break
      fi
  done
  
  /bin/rm -rf /config/_reboot/tve/*
  /bin/sync

  
  if [ ! -f /opt/etc/reboot_mode ]; then
    /bin/systemctl reboot
  fi
elif [[ "$1" == *"apache"* ]]; then
  /bin/sleep $2
  tve_homecalling_api_running=$(ps -C homecalling-api.sh --no-headers | wc -l)
  while [ "$tve_homecalling_api_running" -eq 1 ]; do
    echo "Homecalling-api is still running, postponing apache2 reload, sleep $sleep_count "
    sleep 3
    let sleep_count+=1
    if [ "$sleep_count" -ge 100 ]; then
      break
    fi
    tve_homecalling_api_running=$(ps -C homecalling-api.sh --no-headers | wc -l)
  done
  /bin/rm -rf /config/_reboot/apache/*
  /bin/systemctl reload apache2
else
  echo "Usage: delayed_reboot ucpe <delay in seconds>"
  exit 1
fi
