#! /usr/bin/env python3
import os.path
import string
import lzma as xz
import tarfile

def decompress_xz( f_path ):
    f_name = os.path.basename( f_path )
    if not len(f_name): return None

    f_name_p = os.path.dirname( f_path )

    out_file = '.'.join( string.split( f_name, '.' )[:-1] )
    if out_file == f_name: out_file = '%s-decompress' % f_name

    print( '%s' % f_path)
    print( '%s' % out_file if not len(f_name_p) else os.path.join( f_name_p, out_file) )

    with open(f_path, 'rb') as src, open( os.path.join( f_name_p, out_file),'wb') as dst:
        dst.write(xz.decompress(bytes(src.read())))


    return os.path.join( f_name_p, out_file)


def untar( f_path, dst ):
    tar = tarfile.open( f_path )
    tar.extractall( path=dst )
    tar.close()

    
def untar_xv( f_path, dst ):
    d_file = decompress_xz( f_path )
    untar( d_file, dst )
    os.remove( d_file )

def tar_bz2( src, dst ):
    tar = tarfile.open( dst, 'w:bz2' )
    tar.add( src, arcname='' )
    tar.close()

def untar_bz2( src, dst ):
    tar = tarfile.open( src, 'r:*' )
    tar.extractall( dst )
    tar.close()
    pass
