#!/bin/bash
# -*- coding: utf-8 -*-
# coding: utf-8
# vim: tabstop=2 expandtab shiftwidth=2 softtabstop=2
# vim: set fileencoding=utf-8
set -o nounset
set -o pipefail
set -o errexit
#
rm -rf /run/backup_heat_size /run/backup_glance_size /run/backup_mysql_size /run/backup_libvirt_size /run/backup_nova_size /run/br-now \
   /run/progress_backup_mysql /run/progress_backup_libvirt /run/progress_backup_nova /run/progress_backup_glance /run/progress_backup_heat \
   /run/br-percent /run/br-eta
#
mysql=$(du -sb /var/lib/mysql | cut -f1)
libvirt=$(du -sb /etc/libvirt | cut -f1)
nova=$(du -sb /var/lib/nova | cut -f1)
echo ${mysql} > /run/backup_mysql_size
echo ${libvirt} > /run/backup_libvirt_size
echo ${nova} > /run/backup_nova_size
#
heat=0
glance=0
if [ 1 == $# ] && [ 5 == ${1} ]; then
  heat=$(du -sb /var/lib/heat | cut -f1)
  glance=$(du -sb /var/lib/glance | cut -f1)
  echo ${heat} > /run/backup_heat_size
  echo ${glance} > /run/backup_glance_size
fi
logger -t "freezer_size.sh" "mysql_size ${mysql}"
logger -t "freezer_size.sh" "libvirt_size ${libvirt}"
logger -t "freezer_size.sh" "heat_size ${heat}"
logger -t "freezer_size.sh" "glance_size ${glance}"
logger -t "freezer_size.sh" "nova_size ${nova}"
total=$(expr ${mysql} + ${libvirt} + ${heat} + ${glance} + ${nova})
logger -t "freezer_size.sh" "total_size ${total}"
echo ${total} > /run/freezer_total_size
#
exit 0
