#! /usr/bin/env python3

#import paramiko
import os
import syslog
import ftplib
import subprocess

def sftp_file_get( address, user, pswd, srv_path, local_path ):
    syslog.syslog( syslog.LOG_DEBUG, 'Going sftp://%s/%s to %s' % (address, srv_path, local_path) )

    try:
         subprocess.check_call(['sshpass', '-p', pswd, 'sftp', '-oStrictHostKeyChecking=no', '-oCheckHostIP=no','%s@%s:%s %s' % (user,address,srv_path, local_path)  ] )
    except subprocess.CalledProcessError as e:
        syslog.syslog( syslog.LOG_ERR, '\"%s\" failed with code %d' % (e.cmd, e.returncode) )
        return False
    except OSError as e:
        syslog.syslog( syslog.LOG_ERR, 'Fail - %s' % e.strerror )
        return False

    return True


    
def ftp_file_get( address, user, pswd, srv_path, local_path ):
    
    # Get path and file name
    if srv_path.startswith("/inventory"):
        srv_path = srv_path.lstrip("/inventory")
        
    syslog.syslog( syslog.LOG_DEBUG, 'Going ftp://%s/%s to %s' % (address, srv_path, local_path) )
    try:
        ftp = ftplib.FTP(host=address, user=user, passwd=pswd, timeout=15)


        #Get path and file name
        d_name = os.path.dirname( srv_path )
        f_name = os.path.basename( srv_path )

        #if '' != d_name:
        #    ftp.sendcmd( 'CD %s' % d_name )
            
        loc_file = open( '%s/%s' % (local_path, f_name), 'wb' )

        ftp.retrbinary('RETR %s' % srv_path, loc_file.write)
        #ftp.retrbinary('RETR %s' % f_name, loc_file.write)
        loc_file.close()
    except ftplib.all_errors as e:
        syslog.syslog( syslog.LOG_ERR, 'FTP downoad failed ! -- \'%s\'' % e )
        return False
        
    return True


        
def file_get(proto, address, user, pswd, srv_path, local_path):
    syslog.syslog(syslog.LOG_DEBUG, 'file_get -> %s://%s@%s' % (proto, user, address))
    if None == srv_path:
        syslog.syslog(syslog.LOG_ERR, 'File for download is not specifid')
        return False

    loop=5
    dl_ok = False
    while loop > 0:
        loop -= 1

        if 'sftp' == proto:
            dl_ok = sftp_file_get(address, user, pswd, srv_path, local_path)
        elif 'ftp' == proto:
            dl_ok =  ftp_file_get(address, user, pswd, srv_path, local_path)
        else:
            syslog.syslog(syslog.LOG_ERR, 'Protocol %s is not supported!' % proto)
            return False
        if dl_ok:
            return True
        time.sleep(5)
    

