#!/bin/bash
# -*- coding: utf-8 -*-
source /scripts/basic_vars
source /scripts/basic_functions
#
if [ "$LOG_IN_FILE" -eq 1 ]; then
  enable_logging /var/log/homecalling
fi
#
IOMMU="no"
SRIOV="no"
NICS=
#
if dmesg | grep -iq "iommu enabled" ; then
  IOMMU="yes"
fi
#
dataifs_count=$(get_json_value //config/networking/interfaces $current_config_file | grep data | wc -l)
if [ ${dataifs_count} -ge 1 ] ; then
  for (( index=0 ; index < dataifs_count ; index+=1 )); do
    data_if=data${index}
    if [ -r /sys/class/net/${data_if}/device/sriov_totalvfs ]; then
      NUM_VFS=$(cat /sys/class/net/${data_if}/device/sriov_totalvfs)
      if [ ${NUM_VFS} -ge 1 ]; then
        NICS=$NICS" "${data_if}
        SRIOV="yes"
      fi
    fi
  done
fi
#
cat > $working_dir/capabilities << EOF
export IOMMU="$IOMMU"
export SRIOV="$SRIOV"
export NICS="$NICS"
EOF
#
exit 0
