#!/bin/bash
# -*- mode: sh -*-
# -*- coding: utf-8 -*-
# vim: tabstop=2 expandtab shiftwidth=2 softtabstop=2
# vim: set fileencoding=utf-8
# THIS IS NOT NOT NOT BASH
set -o xtrace
set -o nounset
set -o errexit
#
OUTP="/run/serial"


function get_serial_number() {
  kernel_serial_number=$(cat /proc/cmdline | grep -o "nfvtimeserialnumber=.*\b" | cut -d'=' -f2 || true)
  if [ -n "${kernel_serial_number}" ]; then
    echo "${kernel_serial_number}" > ${OUTP}
    return 0
  fi
  
  sn=`/usr/sbin/dmidecode -s system-serial-number`
  badSerialNumberStrings="Not Specified,Default string,To be filled by O.E.M.,'AKA1234567'"
  if [ -n "${sn}" -a -z "$(grep -i "${sn}" <<< "${badSerialNumberStrings}")" ]; then
    # NFV-14155 : assume hwtype is max 10symbols
    # serial: upto 50    
    echo "${sn}" | tr -dc '[:alnum:]' | cut -c 1-50 > ${OUTP}
  else
    get_serial_from_mac
  fi
} # function setup_serial_number
#

function get_serial_from_mac()   {
mac=""
tmpf=$(mktemp)
pciID=$(lspci | grep -i "Ethernet controller" | grep -v Wireless | cut -d' ' -f1 | sort -u | head -n 1)
echo "${pciID}"
cd /sys/class/net/
for i in *; do
  if [ -z "$(echo $i|grep -i lo || true)" ];then
    fallbackmac=$(cat ${i}/address)
    if [ -f ${i}/device/uevent ]; then
      PCI_SLOT_NAME=$(grep PCI_SLOT_NAME ${i}/device/uevent | cut -d'=' -f2 || true)
      if [ -z "${PCI_SLOT_NAME}" ]; then
        continue
      fi
      mac=$(cat ${i}/address)
      echo -n "${i} "
      echo -n "${mac} "
      echo "${PCI_SLOT_NAME}" > ${tmpf}
      grep -i ${pciID} ${tmpf} && :
      if [ 0 -eq $? ]; then
        #first MAC address found, break
        break
      fi
    fi
  fi
done
rm -f ${tmpf}
if [ -z "${mac}" ]; then
mac=${fallbackmac}
fi
echo "${mac}" | tr -d ':' > ${OUTP}
}


get_serial_number
