#!/bin/bash
# -*- coding: utf-8 -*-
# coding: utf-8
# vim: tabstop=2 expandtab shiftwidth=2 softtabstop=2
# vim: set fileencoding=utf-8
CLUSTER_FILE=/run/cluster.json
TELCOSECRET="RIYljGjlpBKPfWkAEVAPTBIlTraKLjHGt6N74glD7kNZcRGDdW3lHjvfvdjdtixgj2i6DElrIreKZQIMZKwRFfr5rmtRX7bcRS69GnoIIIsWeRGkJrViPqVD9LQ2Zya2bhLTmXsnJI9iQpXCVG7dPY8UrAQjTTPNjlIaI8xjxh2XzGfGAKDqx4lA6iyYVz78Unor0UCKFasE4vYsH8mJogxWInQuXhzLqaEfDhgivpMe19S0bmvPK399Ihf2Bfeg"
read secret
telnet_secret=$(echo ${secret} | tr -d '\r\n')
if [ "${TELCOSECRET}" != "${telnet_secret}" ]; then
  echo "Bad secret !" | systemd-cat -p info -t "healthcheck"
  exit 0
fi
# set -x
data0=$(sysrepocfg --datastore=running --format=json --xpath='/ucpe:config/interfaces:interface[name="data0"]/ipv4-prefix' --export | grep "ipv4-prefix" | cut -d ':' -f 2 | cut -d '/' -f 1 | tr -d '" \n')
nodename=$(sysrepocfg --datastore=running --format=json --xpath="/ucpe:config/system:system/hostname" --export | grep "hostname" | cut -d ':' -f 2 | tr -d '" \n')
role="FAULT"
if [ -f /config/cluster_role ]; then
  role=$(cat /config/cluster_role | tr -d '" \n')
fi
status=$(systemctl is-system-running)
if [ -f ${CLUSTER_FILE} ]; then
  if [ "MASTER" != "${role}" ]; then
    /bin/systemctl reset-failed collectd.service pingManager.service openvpn@client.service sr-currentconfig.service habeat.service 2>/dev/null || true
    rm -f /run/cluster.json
    cp -f /config/cluster.json /run/cluster.json
  fi
fi
echo "{\"nodename\": \"${nodename}\", \"address\": \"${data0}\", \"role\": \"${role}\", \"status\": \"${status}\"}"
exit 0
