#!/bin/bash 

if [ -z $1 ]; then
  current_dir=.
else
  if [ -d $1 ] ; then
    current_dir=$1
  elif [ -f $1 ] ; then
    current_file=$1
  fi

fi

if [ -n "$current_dir" ] ; then
  files=`find $current_dir ! -name "*.sig" -exec sh -c "[[ -f {}.sig ]] && ls {}" \;`
  for file in $files
  do
  setfattr -n security.ima  -v 0x`hexdump -v -e '/1 "%02X"' $file.sig`  $file
  rm -f $file.sig
  done
fi

if [ -n "$current_file" ] ; then
  if [ `getfattr  --only-values -n security.ima  $current_file | wc -c` -ne 137 ] ; then
    evmctl ima_hash $current_file
  fi
fi

exit 0
