#!/usr/bin/env bash
# -*- coding: utf-8 -*-
# coding: utf-8
# vim: tabstop=2 expandtab shiftwidth=2 softtabstop=2
# vim: set fileencoding=utf-8
exec 1> >(systemd-cat -p info -t "keepalivedsh") 2>&1
set -x
echo "${1}--${2}--${3}"
# for pid in $(pidof -x "keepalived.sh"); do
#   if [ ${pid} -ne $$ ]; then
#     echo "Kill ${pid} keepalived.sh my ${$}"
#     kill -9 ${pid}
#   fi
# done
TYPE=${1}
NAME=${2}
STATE=${3}

keepalivedstatepid=$(cat /run/keepalivedstate.pid || true)
case ${STATE} in
  "MASTER")
    echo "${STATE}" > /config/cluster_role
    kill -SIGHUP ${keepalivedstatepid}
    echo -n data0 > /config/_reboot/keepalived/master
    ;;
  "BACKUP" | "FAULT" )
    echo "${STATE}" > /config/cluster_role
    kill -SIGHUP ${keepalivedstatepid}    
    # delete hostname from /etc/hosts
    bind_interface=$(sysrepocfg  -X -x "/ucpe:config/kubernetes:kubernetes/bind-interface" -f xml -d running | grep bind-interface | cut -d '>' -f 2 | cut -d '<' -f1 || true)
    hostname=$(sysrepocfg  -X -x "/ucpe:config/system:system/hostname" -f xml -d running | grep hostname | cut -d '>' -f 2 | cut -d '<' -f1 || true)
    if [ "${hostname}" != "" ] && [ "${bind_interface}" == "tun0" ]; then
      sed -i "/$hostname\$/d" /etc/hosts || true
      sed -i "/controller\$/d" /etc/hosts || true
    fi
    ;;
  *)
    echo "Unknown statate: ${STATE}"
    ;;
esac
#
echo "Done"
#
exit 0
