#!/bin/bash
# -*- coding: utf-8 -*-
# coding: utf-8
# vim: tabstop=2 expandtab shiftwidth=2 softtabstop=2
# vim: set fileencoding=utf-8
if [ -z "${1}" ]; then
  exit 0
fi
exec 1> >(systemd-cat -p info -t "keepalived_to_master") 2>&1
set -x
ifname=$(cat /config/_reboot/keepalived/${1})
rm -f /config/_reboot/keepalived/${1}
if [ -z "${ifname}" ]; then
  exit 0
fi

if [ $(systemctl is-enabled vpp-config) == "enabled" ]; then
  if [ -f /config/central-box ] && [ -f /config/cluster.json ]; then
    virtualip=$(/usr/bin/jq .virtual_address /config/cluster.json | tr -d '"' | xargs)
    etheraddr=$(ip addr list dev ${ifname} | grep 'ether' | awk '{print $2}')
    if [ -n "${virtualip}" ] && [ -n "${etheraddr}" ] ; then
      out=$(vppctl show ip neighbor | grep " ${virtualip} " | grep -v ${etheraddr} | head -1 | awk '{print $4 "," $5}')
      if [ -n "${out}" ]; then
        vppmac=$(echo ${out} | cut -f1 -d',' | xargs)
        vppif=$(echo ${out} | cut -f2 -d',' | xargs)
        if [ -n "${vppmac}" ] && [ -n "${vppif}" ] ; then
          vppctl set ip neighbor del ${vppif} ${virtualip} ${vppmac}
        fi
      fi
    fi
  fi
fi
exit 0
