#!/bin/bash
# -*- coding: utf-8 -*-
# coding: utf-8
# vim: tabstop=2 expandtab shiftwidth=2 softtabstop=2
# vim: set fileencoding=utf-8
set -o nounset
set -o pipefail
# can exit with error set -o errexit
set -o xtrace

#in sec
TIME_DEF=600
TIME_ERR=300
TIMEOUT=$TIME_DEF

. /root/admin-openrc.sh 1>/dev/null 2>/dev/null || true

while $(sleep 300); do
    systemctl is-system-running | grep -qE "running|degraded" || true
        retcode=$?
        if [ $retcode -eq 0 ]; then
                break
        fi

  systemctl reset-failed grub-initrd-fallback.service  2>/dev/null 1>/dev/null || true
  systemctl reset-failed  ifup@br\\x2dlte1.service 2>/dev/null 1>/dev/null || true
  systemctl reset-failed  ifup@br\\x2dlte2.service 2>/dev/null 1>/dev/null || true
  systemctl reset-failed  ifup@br\\x2d*.service 2>/dev/null 1>/dev/null || true
  systemctl reset-failed cloud-final.service 2>/dev/null 1>/dev/null || true
  
done

#workaround for NFV-16572 Console ( ttyS0) is often lost due to timeout when rebooting Audiocodes OSN11
/scripts/ttyS0revive.sh 2>/dev/null 2>/dev/null 1>/dev/null || true 

systemctl reset-failed grub-initrd-fallback.service 2>/dev/null 1>/dev/null || true
systemctl reset-failed cloud-final.service 2>/dev/null 1>/dev/null || true

#if [ "$(systemctl is-enabled neutron-openvswitch-agent.service)" == "enabled" ]; then
    #/usr/bin/neutron --insecure --http-timeout 10 agent-list
    #ret=$?
    #if [ "$ret" != "0" ]; then
        
	    #cat /config/vm-ports.info  | grep flow | egrep "phy-br|br-int"  > /var/tmp/flows.sh || true
	    
	    #/bin/bash /var/tmp/flows.sh  || true
    #fi
#fi


while true; do
  sleep ${TIMEOUT}
  systemctl reset-failed  ifup@br\\x2dlte1.service 2>/dev/null 1>/dev/null || true
  systemctl reset-failed  ifup@br\\x2dlte2.service 2>/dev/null 1>/dev/null || true
  systemctl reset-failed  ifup@br\\x2d*.service 2>/dev/null 1>/dev/null || true
  systemctl reset-failed grub-initrd-fallback.service 2>/dev/null 1>/dev/null || true
  systemctl reset-failed cloud-final.service 2>/dev/null 1>/dev/null || true

  /scripts/setup_lte_qmi_dev.py
  retVal=$?
  if [ $retVal -ne 0 ]; then
     TIMEOUT=$TIME_ERR
  else
     TIMEOUT=$TIME_DEF
  fi
  
  # if [ $(systemctl is-enabled libvirtd) == "enabled" ]; then
  #    timeout 10s /scripts/virsh-save-ports.sh  2>/dev/null 1>/dev/null || true
  # fi
  
  #if manager was not contacted for >=48h, remove license!
  if [ ! -f "/config/central-box" ]; then
    if [ -f "/config/license/ucpe_license.lic" ]; then 
        recentmanagerontacted=$(find /run -name manager-contacted -mtime +1)
        if [[ -n "${recentmanagerontacted}" ]]; then
                touch /run/manager-contacted
                logger -p daemon.warn "Manager not contacted for 48H, removing license!"
                /scripts/cli/tvesh/license_handle.sh unregister &
                sleep ${TIMEOUT}
        fi
    fi
  fi

done
