#!/bin/bash

source /scripts/basic_vars
source /scripts/basic_functions

if [ "$LOG_IN_FILE" -eq 1 ]; then
  enable_logging /var/log/homecalling
fi

vpn_file=$(ls -t /config/_openvpn_up_bind_if_handle/ | head -1)

if [ ! -s /config/_openvpn_up_bind_if_handle/$vpn_file ]; then
  echo "File is empty.. Exiting..."
  /bin/rm -f /config/_openvpn_up_bind_if_handle/$vpn_file
  exit 1
fi

update_bind_address(){
  new_ip=$2
  old_ip=$3
  #if [ -z "$new_ip" ] ; then all the time check for IPv6 address first, no matter VPN comes with IPv6
       new_ip=$(ifconfig $1 | grep "inet6 " | grep -v -e "fe80:" | awk '{print $2}')
      if [ -z "$new_ip" ] ; then
          new_ip=$(ifconfig $1 | grep "inet " | awk '{print $2}')
      fi
  #fi
  if [ -z "$new_ip" ] ; then
    new_ip=$2
  fi

  bind_interface=$(sysrepocfg --datastore=running --format=xml -X --xpath="/ucpe:config/kubernetes:kubernetes/bind-interface" | grep bind-interface | cut -d '>' -f 2 | cut -d '<' -f1)
  cbox_state=$(sysrepocfg --datastore=running --format=xml -X --xpath=/ucpe:config/kubernetes:kubernetes/cbox/enabled | grep enabled | cut -d '>' -f 2 | cut -d '<' -f1)

  CHANGE_IP=0

  vlan_if=$(echo $1 | cut -d. -f1)

  # New address will be assigned without sysrepo knowledge, so inform current config subscriber to can manage that situation
  if [ "$cbox_state" == "true" ] && [ -n "$bind_interface" ]; then
    if [ "$bind_interface" == "$1" ] || [ "br-$bind_interface" == "$1" ]; then
      echo -e "$1\n$new_ip" > /tmp/newcbox_ip
    elif [ "$bind_interface" == "$vlan_if" ]; then
      echo -e "$bind_interface\n$new_ip" > /tmp/newcbox_ip
    fi
    rm -rf /config/_sendconfig/config/*
    mkdir -p /config/_sendconfig/config/config
  fi

  if [ -n "$bind_interface" ] ; then
    if [ "$bind_interface" == "$1" ] || [ "br-$bind_interface" == "$1" ] || [ "$bind_interface" == "$vlan_if" ]; then
      if  [ "$cbox_state" == "true" ]; then
        if [ -n "$new_ip" ] ; then
          CHANGE_IP=1
        fi
      fi

      if [ -n "$new_ip" ]; then
        if [ -z "$old_ip" ]; then
          CHANGE_IP=1
        elif [ "$old_ip" != "$new_ip" ]; then
          CHANGE_IP=1
        fi
      fi
    fi
  fi

  if [ "$CHANGE_IP" -eq 1 ]; then
    /scripts/set_openstack_address.sh $new_ip "force_rebind"
  fi

  touch $hb_force_file
}


arg=`cat /config/_openvpn_up_bind_if_handle/$vpn_file`
if [[ ! -z "$arg" && "$arg" =~ ^tun0 ]]; then
  update_bind_address $arg
fi

if [ -f /config/_openvpn_up_bind_if_handle/$vpn_file ]; then
  /bin/rm -f /config/_openvpn_up_bind_if_handle/$vpn_file
fi

exit 0
