#!/bin/bash
# -*- coding: utf-8 -*-
# coding: utf-8
# vim: tabstop=2 expandtab shiftwidth=2 softtabstop=2
# vim: set fileencoding=utf-8
set -o nounset
set -o pipefail
set -o errexit
#
function getpercent() {
  mp=$(cat ${1} | tr '?' '\n' | tr '\r' '\n' | awk 'NF > 0' | cut -d'^' -f1 | tr -d '\%' | awk '{print $3}' | tail -n1)
  echo ${mp}
} # function getpercent
function geteta() {
  mye=$(cat ${1} | tr '?' '\n' | tr '\r' '\n' | awk 'NF > 0' | cut -d'^' -f2 | awk '{print $2}' | tail -n1)
  if [ -n "${mye}" ]; then
    echo ${mye}
    return
  else
    echo 0
    return
  fi
  echo 0
} # function geteta
function getrate() {
  myr=$(cat ${1} | tr '?' '\n' | tr '\r' '\n' | awk 'NF > 0' | cut -d'^' -f3 | tr -d '[]' | tail -n1)
  mk=$(echo ${myr: -5})
  mv=$(echo ${myr: 0:-5})
  logger -t "parseprogress.sh" "getrate ${myr}"
  logger -t "parseprogress.sh" "getrate ${mk}"
  logger -t "parseprogress.sh" "getrate ${mv}"  
  if [[ ${mk} == *"MiB/s"* ]]; then
    echo $(echo "${mv} * 1024 * 1024"|bc)
    return
  elif [[ ${mk} == *"KiB/s"* ]]; then
    echo $( echo "${{mv} * 1024"|bc)
    return
  else
    echo 0
    return
  fi
  echo 0
} # function getrate
#
myn="unknown"
if [ -f /run/br-now ]; then
  myn=$(cat /run/br-now)
fi
#
if [ "percent" = "${1}" ]; then
  if [ "${myn}" = "backup_mysql" ]; then
    mysql_percent=$(getpercent /run/progress_backup_mysql)
    logger -t "parseprogress.sh" "backup-restore-now ${myn}"
    logger -t "parseprogress.sh" "mysql_percent ${mysql_percent}"
    echo ${mysql_percent} > /run/br-percent
  elif [ "${myn}" = "backup_libvirt" ]; then
    total_size=$(cat /run/freezer_total_size)
    mysql_percent=$(getpercent /run/progress_backup_mysql)
    mysql_size=$(cat /run/backup_mysql_size)
    mysql_weight=$((${mysql_percent}+${mysql_size}/${total_size}))
    libvirt_percent=$(getpercent /run/progress_backup_libvirt)
    libvirt_size=$(cat /run/backup_libvirt_size)
    libvirt_weight=$((${libvirt_percent}+${libvirt_size}/${total_size}))
    logger -t "parseprogress.sh" "backup-restore-now ${myn}"
    logger -t "parseprogress.sh" "mysql_percent ${mysql_percent} mysql_size ${mysql_size} libvirt_percent ${libvirt_percent} libvirt_size ${libvirt_size} total_size ${total_size}"
    logger -t "parseprogress.sh" "mysql_percent+mysql_size/total_size ${mysql_weight}"
    logger -t "parseprogress.sh" "libvirt_percent+libvirt_size/total_size ${libvirt_weight}"
    percent=$((${mysql_weight} + ${libvirt_weight}))
    logger -t "parseprogress.sh" "percent ${percent}"
    echo ${percent} > /run/br-percent
  elif [ "${myn}" = "backup_heat" ]; then
    total_size=$(cat /run/freezer_total_size)
    mysql_percent=$(getpercent /run/progress_backup_mysql)
    mysql_size=$(cat /run/backup_mysql_size)
    mysql_weight=$((${mysql_percent}+${mysql_size}/${total_size}))
    libvirt_percent=$(getpercent /run/progress_backup_libvirt)
    libvirt_size=$(cat /run/backup_libvirt_size)
    libvirt_weight=$((${libvirt_percent}+${libvirt_size}/${total_size}))
    heat_percent=$(getpercent /run/progress_backup_heat)
    heat_size=$(cat /run/backup_heat_size)
    heat_weight=$((${heat_percent}+${heat_size}/${total_size}))
    logger -t "parseprogress.sh" "backup-restore-now ${myn}"
    logger -t "parseprogress.sh" "mysql_percent ${mysql_percent} mysql_size ${mysql_size} libvirt_percent ${libvirt_percent} libvirt_size ${libvirt_size} heat_percent ${heat_percent} heat_size ${heat_size} total_size ${total_size}"
    logger -t "parseprogress.sh" "mysql_percent+mysql_size/total_size ${mysql_weight}"
    logger -t "parseprogress.sh" "libvirt_percent+libvirt_size/total_size ${libvirt_weight}"
    logger -t "parseprogress.sh" "heat_percent+heat_size/total_size ${heat_weight}"
    percent=$((${mysql_weight} + ${libvirt_weight} + ${heat_weight}))
    logger -t "parseprogress.sh" "percent ${percent}"
    echo ${percent} > /run/br-percent
  elif [ "${myn}" = "backup_glance" ]; then
    total_size=$(cat /run/freezer_total_size)
    mysql_percent=$(getpercent /run/progress_backup_mysql)
    mysql_size=$(cat /run/backup_mysql_size)
    mysql_weight=$((${mysql_percent}+${mysql_size}/${total_size}))
    libvirt_percent=$(getpercent /run/progress_backup_libvirt)
    libvirt_size=$(cat /run/backup_libvirt_size)
    libvirt_weight=$((${libvirt_percent}+${libvirt_size}/${total_size}))
    heat_percent=$(getpercent /run/progress_backup_heat)
    heat_size=$(cat /run/backup_heat_size)
    heat_weight=$((${heat_percent}+${heat_size}/${total_size}))
    glance_percent=$(getpercent /run/progress_backup_glance)
    glance_size=$(cat /run/backup_glance_size)
    glance_weight=$((${glance_percent}+${glance_size}/${total_size}))
    logger -t "parseprogress.sh" "backup-restore-now ${myn}"
    logger -t "parseprogress.sh" "mysql_percent ${mysql_percent} mysql_size ${mysql_size} libvirt_percent ${libvirt_percent} libvirt_size ${libvirt_size} heat_percent ${heat_percent} heat_size ${heat_size} glance_percent ${glance_percent} glance_size ${glance_size} total_size ${total_size}"
    logger -t "parseprogress.sh" "mysql_percent+mysql_size/total_size ${mysql_weight}"
    logger -t "parseprogress.sh" "libvirt_percent+libvirt_size/total_size ${libvirt_weight}"
    logger -t "parseprogress.sh" "heat_percent+heat_size/total_size ${heat_weight}"
    logger -t "parseprogress.sh" "glance_percent+glance_size/total_size ${glance_weight}"
    percent=$((${mysql_weight} + ${libvirt_weight} + ${heat_weight} + ${glance_weight}))
    logger -t "parseprogress.sh" "percent ${percent}"
    echo ${percent} > /run/br-percent
  elif [ "${myn}" = "backup_nova" ]; then
    total_size=$(cat /run/freezer_total_size)
    mysql_percent=$(getpercent /run/progress_backup_mysql)
    mysql_size=$(cat /run/backup_mysql_size)
    mysql_weight=$((${mysql_percent}+${mysql_size}/${total_size}))
    libvirt_percent=$(getpercent /run/progress_backup_libvirt)
    libvirt_size=$(cat /run/backup_libvirt_size)
    libvirt_weight=$((${libvirt_percent}+${libvirt_size}/${total_size}))
    nova_percent=$(getpercent /run/progress_backup_nova)
    nova_size=$(cat /run/backup_nova_size)
    nova_weight=$((${nova_percent}+${nova_size}/${total_size}))
    logger -t "parseprogress.sh" "backup-restore-now ${myn}"
    logger -t "parseprogress.sh" "mysql_percent ${mysql_percent} mysql_size ${mysql_size} libvirt_percent ${libvirt_percent} libvirt_size ${libvirt_size} nova_percent ${nova_percent} nova_size ${nova_size} total_size ${total_size}"
    logger -t "parseprogress.sh" "mysql_percent+mysql_size/total_size ${mysql_weight}"
    logger -t "parseprogress.sh" "libvirt_percent+libvirt_size/total_size ${libvirt_weight}"
    logger -t "parseprogress.sh" "nova_percent+nova_size/total_size ${nova_weight}"
    percent=$((${mysql_weight} + ${libvirt_weight} + ${nova_weight}))    
    if [ -f /run/progress_backup_heat ]; then
      heat_percent=$(getpercent /run/progress_backup_heat)
      heat_size=$(cat /run/backup_heat_size)
      heat_weight=$((${heat_percent}+${heat_size}/${total_size}))
      logger -t "parseprogress.sh" "heat_percent+heat_size/total_size ${heat_weight}"
      percent=$((${mysql_weight} + ${libvirt_weight} + ${heat_weight} + ${nova_weight}))
    fi
    if [ -f /run/progress_backup_glance ]; then
      glance_percent=$(getpercent /run/progress_backup_glance)
      glance_size=$(cat /run/backup_glance_size)
      glance_weight=$((${glance_percent}+${glance_size}/${total_size}))
      logger -t "parseprogress.sh" "glance_percent+glance_size/total_size ${glance_weight}"      
      percent=$((${mysql_weight} + ${libvirt_weight} + ${heat_weight} + ${glance_weight} + ${nova_weight}))      
    fi    
    logger -t "parseprogress.sh" "percent ${percent}"
    echo ${percent} > /run/br-percent
  else
    logger -t "parseprogress.sh" "FAIL can not calculate percent for ${myn}"
  fi
elif [ "eta" = "${1}" ]; then
  if [ "${myn}" = "backup_mysql" ]; then
    mysql_eta=$(geteta /run/progress_backup_mysql)
    logger -t "parseprogress.sh" "backup-restore-now ${myn}"
    logger -t "parseprogress.sh" "mysql_eta ${mysql_eta}"
    echo ${mysql_eta} > /run/br-eta
  elif [ "${myn}" = "backup_libvirt" ]; then
    total_size=$(cat /run/freezer_total_size)
    mysql_percent=$(getpercent /run/progress_backup_mysql)
    mysql_size=$(cat /run/backup_mysql_size)
    mysql_weight=$((${mysql_percent}+${mysql_size}/${total_size}))
    libvirt_percent=$(getpercent /run/progress_backup_libvirt)
    libvirt_size=$(cat /run/backup_libvirt_size)
    libvirt_weight=$((${libvirt_percent}+${libvirt_size}/${total_size}))
    libvirt_rate=$(getrate /run/progress_backup_libvirt)
    logger -t "parseprogress.sh" "backup-restore-now ${myn}"
    logger -t "parseprogress.sh" "mysql_percent ${mysql_percent} mysql_size ${mysql_size} libvirt_percent ${libvirt_percent} libvirt_size ${libvirt_size} total_size ${total_size}"
    logger -t "parseprogress.sh" "mysql_percent+mysql_size/total_size ${mysql_weight}"
    logger -t "parseprogress.sh" "libvirt_percent+libvirt_size/total_size ${libvirt_weight}"
    percent=$((${mysql_weight} + ${libvirt_weight}))
    logger -t "parseprogress.sh" "percent ${percent}"
    total_eta=$((${total_size}-${percent}/${total_size}))
    logger -t "parseprogress.sh" "libvirt_rate ${libvirt_rate} B/s"
    total_eta_rate=$(echo "${total_eta}/${libvirt_rate}"|bc)
    logger -t "parseprogress.sh" "total_eta ${total_eta} total_eta_rate ${total_eta_rate}"
    echo ${total_eta_rate} > /run/br-eta
  elif [ "${myn}" = "backup_heat" ]; then
    total_size=$(cat /run/freezer_total_size)
    mysql_percent=$(getpercent /run/progress_backup_mysql)
    mysql_size=$(cat /run/backup_mysql_size)
    mysql_weight=$((${mysql_percent}+${mysql_size}/${total_size}))
    libvirt_percent=$(getpercent /run/progress_backup_libvirt)
    libvirt_size=$(cat /run/backup_libvirt_size)
    libvirt_weight=$((${libvirt_percent}+${libvirt_size}/${total_size}))
    heat_percent=$(getpercent /run/progress_backup_heat)
    heat_size=$(cat /run/backup_heat_size)
    heat_weight=$((${heat_percent}+${heat_size}/${total_size}))
    heat_rate=$(getrate /run/progress_backup_heat)
    #
    logger -t "parseprogress.sh" "backup-restore-now ${myn}"
    logger -t "parseprogress.sh" "mysql_percent ${mysql_percent} mysql_size ${mysql_size} libvirt_percent ${libvirt_percent} libvirt_size ${libvirt_size} heat_percent ${heat_percent} heat_size ${heat_size} total_size ${total_size}"
    logger -t "parseprogress.sh" "mysql_percent+mysql_size/total_size ${mysql_weight}"
    logger -t "parseprogress.sh" "libvirt_percent+libvirt_size/total_size ${libvirt_weight}"
    logger -t "parseprogress.sh" "heat_percent+heat_size/total_size ${heat_weight}"
    percent=$((${mysql_weight} + ${libvirt_weight} + ${heat_weight}))
    logger -t "parseprogress.sh" "percent ${percent}"
    total_eta=$((${total_size}-${percent}/${total_size}))
    logger -t "parseprogress.sh" "heat_rate ${heat_rate} B/s"
    total_eta_rate=$(echo "${total_eta}/${heat_rate}"|bc)
    logger -t "parseprogress.sh" "total_eta ${total_eta} total_eta_rate ${total_eta_rate}"
    echo ${total_eta_rate} > /run/br-eta
  elif [ "${myn}" = "backup_glance" ]; then
    total_size=$(cat /run/freezer_total_size)
    mysql_percent=$(getpercent /run/progress_backup_mysql)
    mysql_size=$(cat /run/backup_mysql_size)
    mysql_weight=$((${mysql_percent}+${mysql_size}/${total_size}))
    libvirt_percent=$(getpercent /run/progress_backup_libvirt)
    libvirt_size=$(cat /run/backup_libvirt_size)
    libvirt_weight=$((${libvirt_percent}+${libvirt_size}/${total_size}))
    heat_percent=$(getpercent /run/progress_backup_heat)
    heat_size=$(cat /run/backup_heat_size)
    heat_weight=$((${heat_percent}+${heat_size}/${total_size}))
    glance_percent=$(getpercent /run/progress_backup_glance)
    glance_size=$(cat /run/backup_glance_size)
    glance_weight=$((${glance_percent}+${glance_size}/${total_size}))
    glance_rate=$(getrate /run/progress_backup_glance)
    #
    logger -t "parseprogress.sh" "backup-restore-now ${myn}"
    logger -t "parseprogress.sh" "mysql_percent ${mysql_percent} mysql_size ${mysql_size} libvirt_percent ${libvirt_percent} libvirt_size ${libvirt_size} heat_percent ${heat_percent} heat_size ${heat_size} glance_percent ${glance_percent} glance_size ${glance_size} total_size ${total_size}"
    logger -t "parseprogress.sh" "mysql_percent+mysql_size/total_size ${mysql_weight}"
    logger -t "parseprogress.sh" "libvirt_percent+libvirt_size/total_size ${libvirt_weight}"
    logger -t "parseprogress.sh" "heat_percent+heat_size/total_size ${heat_weight}"
    logger -t "parseprogress.sh" "glance_percent+glance_size/total_size ${glance_weight}"
    percent=$((${mysql_weight} + ${libvirt_weight} + ${heat_weight} + ${glance_weight}))
    logger -t "parseprogress.sh" "percent ${percent}"
    total_eta=$((${total_size}-${percent}/${total_size}))
    logger -t "parseprogress.sh" "glance_rate ${glance_rate} B/s"
    total_eta_rate=$(echo "${total_eta}/${glance_rate}"|bc)
    logger -t "parseprogress.sh" "total_eta ${total_eta} total_eta_rate ${total_eta_rate}"
    echo ${total_eta_rate} > /run/br-eta
  elif [ "${myn}" = "backup_nova" ]; then
    total_size=$(cat /run/freezer_total_size)
    mysql_percent=$(getpercent /run/progress_backup_mysql)
    mysql_size=$(cat /run/backup_mysql_size)
    mysql_weight=$((${mysql_percent}+${mysql_size}/${total_size}))
    libvirt_percent=$(getpercent /run/progress_backup_libvirt)
    libvirt_size=$(cat /run/backup_libvirt_size)
    libvirt_weight=$((${libvirt_percent}+${libvirt_size}/${total_size}))
    nova_percent=$(getpercent /run/progress_backup_nova)
    nova_size=$(cat /run/backup_nova_size)
    nova_weight=$((${nova_percent}+${nova_size}/${total_size}))
    nova_rate=$(getrate /run/progress_backup_nova)
    logger -t "parseprogress.sh" "backup-restore-now ${myn}"
    logger -t "parseprogress.sh" "mysql_percent ${mysql_percent} mysql_size ${mysql_size} libvirt_percent ${libvirt_percent} libvirt_size ${libvirt_size} nova_percent ${nova_percent} nova_size ${nova_size} total_size ${total_size}"
    logger -t "parseprogress.sh" "mysql_percent+mysql_size/total_size ${mysql_weight}"
    logger -t "parseprogress.sh" "libvirt_percent+libvirt_size/total_size ${libvirt_weight}"
    logger -t "parseprogress.sh" "nova_percent+nova_size/total_size ${nova_weight}"
    percent=$((${mysql_weight} + ${libvirt_weight} + ${nova_weight}))
    if [ -f /run/progress_backup_heat ]; then
      heat_percent=$(getpercent /run/progress_backup_heat)
      heat_size=$(cat /run/backup_heat_size)
      heat_weight=$((${heat_percent}+${heat_size}/${total_size}))
      logger -t "parseprogress.sh" "heat_percent+heat_size/total_size ${heat_weight}"
      percent=$((${mysql_weight} + ${libvirt_weight} + ${heat_weight} + ${nova_weight}))
    fi
    if [ -f /run/progress_backup_glance ]; then
      glance_percent=$(getpercent /run/progress_backup_glance)
      glance_size=$(cat /run/backup_glance_size)
      glance_weight=$((${glance_percent}+${glance_size}/${total_size}))
      logger -t "parseprogress.sh" "glance_percent+glance_size/total_size ${glance_weight}"      
      percent=$((${mysql_weight} + ${libvirt_weight} + ${heat_weight} + ${glance_weight} + ${nova_weight}))      
    fi
    logger -t "parseprogress.sh" "percent ${percent}"
    total_eta=$((${total_size}-${percent}/${total_size}))
    logger -t "parseprogress.sh" "nova_rate ${nova_rate} B/s"
    total_eta_rate=$(echo "${total_eta}/${nova_rate}"|bc)
    logger -t "parseprogress.sh" "total_eta ${total_eta} total_eta_rate ${total_eta_rate}"
    echo ${total_eta_rate} > /run/br-eta
  else
    logger -t "parseprogress.sh" "FAIL eta ${myn}"
  fi
else
  logger -t "parseprogress.sh" "FAIL can not calculate eta for ${myn}"
  exit 0
fi
exit 0
