import ast
import json
import sys


def set_pci_whitelist(action, devname, physical_network, current_list):
    if action == 'add':
        new_pci = {"devname": devname, "physical_network": physical_network}
        current_list.append(new_pci)
    elif action == 'remove':
        current_list[:] = [pci for pci in current_list if
                           pci['devname'] != devname]


if __name__ == '__main__':
    action = sys.argv[1]
    devname = sys.argv[2]
    physical_network = sys.argv[3]
    try:
        current_list = ast.literal_eval(sys.argv[4].strip())
    except:
        current_list = []
    set_pci_whitelist(action, devname, physical_network, current_list)
    print(json.dumps(current_list))
