#! /usr/bin/env python3
import sys
import glob
import json
from tveapi.json_tools import json_tools as jt
import subprocess

CFG_FILE = "/config/ucpe_config.json"

def enable_splash():

    if not glob.glob("/etc/apache2/conf-enabled/splash.*"):
        subprocess.check_call(['a2enconf', 'splash'])

def setup_dhcp_srv():

    cfg_f = open(CFG_FILE, "r")
    cfg = json.load(cfg_f)
    intf_cfg = jt.get_nested_node(cfg,['ucpe:config','interfaces:interface'])
    for c_if in intf_cfg:
        if c_if['name'] and 'data' in c_if['name']:
            if c_if['name'] == "data0":
                continue
            int_type = subprocess.check_output("/sbin/ethtool {} | grep \"Transceiver:\" | cut -d\':\' -f2".format(c_if['name']), shell=True).decode()
            port_type = subprocess.check_output("/sbin/ethtool {} | grep \"Port:\" | cut -d\':\' -f2".format(c_if['name']), shell=True).decode()
            if "internal" in str(int_type) and any([x in str(port_type) for x in ["Twisted Pair", "Other"]]):
                c_if['ipv4-prefix'] = '10.1.100.1/24'
                c_if['management'] = True
                if cfg['ucpe:config']['dhcpserver:dhcp-server']:
                    cfg['ucpe:config']['dhcpserver:dhcp-server']['dhcp-bind-interface'] = c_if['name']
                break

    cfg_f.close()
    cfg_f = open(CFG_FILE, 'w')
    new_cfg = json.dumps( cfg, indent=4, sort_keys=True, separators=(',', ': ') )
    cfg_f.write(new_cfg)
    cfg_f.close()

if __name__=="__main__":

    enable_splash()
    setup_dhcp_srv()
    sys.exit(0)
