#!/bin/bash
# -*- coding: utf-8 -*-
#set -x
#exec 1> >(systemd-cat -p info -t ssh_successful_auth.sh) 2>&1
source /scripts/ipv6_functions

session_pid=$(ps --no-headers -eo ppid -fp $$ | tr -d ' ')
psession_pid=$(ps --no-headers -eo ppid -fp ${session_pid} | tr -d ' ')
USER=${1}
PASS=${2}
GROUP=${3}
if [[ 4 -eq ${#} ]]; then
  psession_pid=${4}
fi
command_header="curl -s --connect-timeout 5 --insecure"
LOCAL_TOKEN=""
LOCAL_EXPIRE=""
CONTROLLER_TOKEN=""
CONTROLLER_EXPIRE=""
#
function get_local_token() {
  local output=$(mktemp)

  #echo $output
  local get_local_token_command="${command_header} -d '{\"user\":\"${USER}\", \"password\":\"${PASS}\"}' -H Content-type: application/json -X GET https://localhost:7374/v3/auth/tokens"
  eval "$get_local_token_command" > "$output"
  LOCAL_TOKEN=$(cat "$output")
    #LOCAL_TOKEN=$(awk '/X-Subject-Token/ {print $2}' $output | tr -d '\r')
    #if [ -n "${LOCAL_TOKEN}" ]; then
    #  LOCAL_EXPIRE=$(sed -e '1,10d' < $output | python3 -mjson.tool | awk '/\yexpires_at\y/ {print $2}' | tr -d '\r' | tr -d '"' | tr -d ',' | awk -F. '{print $1}')
    #fi
  rm -f ${output}
}
#

function main() {
  get_local_token

  cat > /tmp/token.${psession_pid} << _EOF_
session_pid=${psession_pid}
username=${USER}
password=${PASS}
group=${GROUP}
token=${LOCAL_TOKEN}

_EOF_

  chmod a+w /tmp/token.${psession_pid}
}

main
exit 0
