#!/bin/bash
# -*- coding: utf-8 -*-
# coding: utf-8
# vim: tabstop=2 expandtab shiftwidth=2 softtabstop=2
# vim: set fileencoding=utf-8
set -o nounset
set -o pipefail
set -o errexit
#
if [ "1" != "$#" ]; then exit 0; fi
LEDTRIGGER=/sys/class/leds/status_led/trigger
if [ ! -f ${LEDTRIGGER} ]; then exit 0; fi
exec 1> >(systemd-cat -p info -t systemled) 2>&1
set -o xtrace
SLEEP=${1}
function returntodefault {
  echo "heartbeat" > ${LEDTRIGGER}
  exit 0
}
trap returntodefault SIGINT SIGKILL SIGTERM SIGABRT ERR
#
set +o xtrace
while true; do
  echo "default-on" > ${LEDTRIGGER}
  sleep ${SLEEP}
  echo "none" > ${LEDTRIGGER}
  sleep ${SLEEP}
done
#
exit 0
