#!/bin/bash
SLEEPTIME=3

TTYSTAT=$(systemctl status dev-ttyS0.device | grep -i timeout)
if [[ -z "${TTYSTAT}" ]]; then
#echo "No problem in ttyS0. Exit"
exit 0
fi

GETTYNOK=$(cat /lib/systemd/system/serial-getty@.service | grep -i "sbin/agetty -o ")
if [[ -n "${GETTYNOK}" ]]; then
sed -i 's|^ExecStart=-/sbin/agetty -o.*|ExecStart=-/sbin/agetty --keep-baud 115200,38400,9600 %I $TERM|' /lib/systemd/system/serial-getty@.service
fi

#Fallback
DEVID="00:04"
DRVPATH="/sys/bus/pnp/drivers/serial"
DEVPATH="/sys/class/tty/ttyS0"

if [ -d /sys/class/tty/ttyS0 ]; then
cd ${DEVPATH}
cd -P device && DEVID=`basename "$PWD"`
cd -P driver && DRVPATH=$PWD
fi

systemctl daemon-reload
sleep ${SLEEPTIME}
echo ${DEVID} > ${DRVPATH}/unbind
sleep ${SLEEPTIME}
echo ${DEVID} > ${DRVPATH}/bind
sleep ${SLEEPTIME}
systemctl daemon-reload
sleep ${SLEEPTIME}
systemctl restart systemd-udevd.service systemd-udev-trigger.service 
sleep ${SLEEPTIME}
systemctl stop serial-getty@ttyS0.service --no-ask-password 
sleep ${SLEEPTIME}
systemctl start serial-getty@ttyS0.service --no-ask-password 
sleep ${SLEEPTIME}
systemctl restart systemd-logind.service
sleep ${SLEEPTIME}




# Repeat twice!!

systemctl daemon-reload
sleep ${SLEEPTIME}
echo ${DEVID} > ${DRVPATH}/unbind
sleep ${SLEEPTIME}
echo ${DEVID} > ${DRVPATH}/bind
sleep ${SLEEPTIME}
systemctl daemon-reload
sleep ${SLEEPTIME}
systemctl restart systemd-udevd.service systemd-udev-trigger.service
sleep ${SLEEPTIME}
systemctl stop serial-getty@ttyS0.service --no-ask-password
sleep ${SLEEPTIME}
systemctl start serial-getty@ttyS0.service --no-ask-password
sleep ${SLEEPTIME}
systemctl restart systemd-logind.service
sleep ${SLEEPTIME}

