#!/bin/bash
#source /scripts/basic_vars
#source /scripts/basic_functions
#set -x
vmportsinfo="/config/vm-ports.info"

exit 0

echo -n "">${vmportsinfo}
rm -f  /var/tmp/bd*.txt 
if [ $(systemctl is-enabled vpp-config) == "enabled" ]; then

 vppctl show bridge-domain | grep -v BD-ID | sed -e 's/^[[:space:]]*//' |cut -f1 -d' ' > /var/tmp/bdall.txt
 for vmid in $(virsh list 2>&1 | tail -n +3 | sed -e 's/^[[:space:]]*//' | cut -f1 -d' '); do
   for vhostsock in $(virsh dumpxml ${vmid} | egrep -o "<source type='unix'\s+path='/tmp/([-A-Za-z0-9]+)'\s+mode='server'/>" | cut -f3 -d'/' | cut -f1 -d"'"); do
      vhostifname=$(vppctl show vhost | egrep "socket filename|Interface:" | sed 's/"Success"/#/' | tr -s '\r\n' ',' | tr -s '#' '\n' | grep ${vhostsock} | cut -f2 -d' ')
      tapif=""
      dataif=""
      for bdid in $(cat /var/tmp/bdall.txt); do
              if [ ! -f "/var/tmp/bd${bdid}.txt" ]; then
                       vppctl show bridge-domain ${bdid} detail > "/var/tmp/bd${bdid}.txt"
              fi

              bdmatch=$(cat "/var/tmp/bd${bdid}.txt" | grep ${vhostifname} |xargs)
              if [[ -n "${bdmatch}" ]]; then
                   tapif=$(cat "/var/tmp/bd${bdid}.txt" | grep tap | head -1 | xargs| cut -f1 -d' ')
                   if [[ -z "${tapif}" ]]; then tapif="none" ; fi
                   dataif=$(cat "/var/tmp/bd${bdid}.txt" | tail -n +5 | egrep -v "BVI|loop|tap|Virtual" | head -1 | xargs| cut -f1 -d' ')
                   sysrepodataif=${dataif/host-/}
                   if [[ -z "${dataif}" ]]; then dataif="none" ; fi
                   break
              fi
      done

  passthr="false"
  if [[ -n "${sysrepodataif}" ]]; then
          passthr=$(sysrepocfg --datastore=running --format=json --xpath="/ucpe:config/interfaces:interface[name='${sysrepodataif}']/ip-passthrough" --export | grep ip-passthrough | cut -f 2 -d ':' | xargs)
  fi
  
  if [[ ! -n "${passthr}" ]]; then
    passthr="false"
  fi

  echo "$vhostsock $tapif $passthr $dataif $bdid" >> ${vmportsinfo}
  done
 done


else
#OVS
for phyportname in $(ovs-vsctl list Interface | grep name | grep phy- | cut -f 2 -d':' | tr -d '"' | tr -d ' '); do
        phybrname=${phyportname/phy-/}
        intportname="int-${phybrname}"
        systemmatch=$(ovs-ofctl dump-ports --names br-int-system | grep ${intportname})
        if [[ -n "${systemmatch}" ]]; then
                intbrname="br-int-system"
        else
                intbrname="br-int-netdev"
        fi
        echo "ovs-vsctl add-port ${phybrname} ${phyportname} -- set interface ${phyportname} type=patch -- set interface ${phyportname} options:peer=${intportname}" >> ${vmportsinfo}
        echo "ovs-vsctl add-port ${intbrname} ${intportname} -- set interface ${intportname} type=patch -- set interface ${intportname} options:peer=${phyportname}" >> ${vmportsinfo}
        SAVEIFS=$IFS
        IFS=$'\n'
        for flow in $(ovs-ofctl dump-flows -O OpenFlow13 --no-stats --names ${phybrname}  | grep phy |  egrep "drop|vlan|213|215" | sed 's/cookie=0x[^,]*,/cookie=0xa000000000000000,/'  | tr -d '"') ; do
                echo "ovs-ofctl add-flow -O OpenFlow13 ${phybrname} \"${flow}\"" >> ${vmportsinfo}
        done
        IFS=$SAVEIFS
        echo "ovs-ofctl add-flow ${phybrname} \"cookie=0xa000000000000000,table=213,priority=1 actions=NORMAL\"" >> ${vmportsinfo}
 done

 SAVEIFS=$IFS
        IFS=$'\n'

 for flow in $( ovs-ofctl dump-flows --no-stats --names br-int-system  | egrep "int-"  | sed 's/cookie=0x[^,]*,//' | tr -d '"'); do
         echo "ovs-ofctl add-flow br-int-system \"${flow}\""  >> ${vmportsinfo}
 done

 for flow in $( ovs-ofctl dump-flows --no-stats --names br-int-netdev  | egrep "int-"  | sed 's/cookie=0x[^,]*,//' | tr -d '"'); do
         echo "ovs-ofctl add-flow br-int-netdev \"${flow}\""  >> ${vmportsinfo}
 done
IFS=$SAVEIFS

 echo "ovs-ofctl add-flow br-int-netdev \"table=60, cookie=0x426616f58339f36e, priority=2 actions=NORMAL\"" >> ${vmportsinfo}
 echo "ovs-ofctl add-flow br-int-system \"table=60, cookie=0x426616f58339f36e, priority=2 actions=NORMAL\"" >> ${vmportsinfo}


 for tapifname in $(ovs-vsctl list Interface | grep name | tr -d '"' | egrep ": vhu|: tap" | cut -f 2 -d':'  | tr -d ' '); do
      tag=$(ovs-vsctl get port ${tapifname} tag)
      if [[ -n "${tag}" ]]; then
           echo "ovs-vsctl set port ${tapifname} tag=${tag}" >> ${vmportsinfo}
           echo "ovs-vsctl set port ${tapifname} vlan_mode=access" >> ${vmportsinfo}
      fi
 done


fi
